/*
 * Copyright 2017-2020 original authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.micronaut.docs.http.server.exception.aterrorexceptionhandlerprecedence;

import io.micronaut.context.annotation.Requires;
import io.micronaut.http.HttpRequest;
import io.micronaut.http.HttpResponse;
import io.micronaut.http.annotation.Controller;
import io.micronaut.http.annotation.Error;

@Requires(property = "spec.name", value = "AtErrorExceptionHandlerPrecedenceSpec")
@Controller("/outofstock")
public class OutOfStockController {

    @Error(exception = OutOfStockException.class, global = true)
    public HttpResponse handleOutOfStock(HttpRequest request) {
        return HttpResponse.ok(-1);
    }
}
