/*
 * Copyright 2017-2020 original authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package io.micronaut.multitenancy.writer;

import io.micronaut.core.util.Toggleable;
import io.micronaut.http.cookie.CookieConfiguration;

/**
 * {@link io.micronaut.multitenancy.writer.CookieTenantWriter} Configuration.
 *
 * @author Sergio del Amo
 * @since 1.0
 */
interface CookieTenantWriterConfiguration extends CookieConfiguration, Toggleable {

    /**
     *
     * @return a Cookie name.
     */
    String getCookiename();
}
